import QtQuick 1.0
import "storage.js" as Settings;

Rectangle {
    id: hiscorepanel
    height: board.height - 100
    width:  board.width/2
    y: 50
    state: "HIDDEN"
    border.color: "#00ff00"
    border.width: 5
    color:  "black"


    states: [
        State {
            name: "HIDDEN"
            PropertyChanges { target: hiscorepanel; x: board.width + 2}
        },
        State {
            name: "VISIBLE"
            PropertyChanges { target: hiscorepanel; x: board.width/2}
        }


    ]

    transitions: Transition {
        NumberAnimation { properties: "x"; easing.type: Easing.InOutQuad }
    }

    //Dummy mouse area to stop events being passed through
    MouseArea {
        anchors.fill: parent
    }

    Text {
        id: hiscoreheader
        text: "Hi Scores"
        font.pixelSize: 30
        anchors.horizontalCenter: hiscorepanel.horizontalCenter
        anchors.top: hiscorepanel.top
        anchors.topMargin: 5
        color:  "#00ff00"
    }

    Text {
        id: lvl
        text: "Level"
        font.pixelSize: 30

        anchors.top: hiscoreheader.bottom
        anchors.topMargin: 10
        anchors.left: pos1.right
        anchors.leftMargin: 30
        color:  "#00ff00"
    }

    Text {
        id: score
        text: "Score"
        font.pixelSize: 30

        anchors.top: hiscoreheader.bottom
        anchors.topMargin: 10
        anchors.left: lvl.right
        anchors.leftMargin: 50
        color:  "#00ff00"
    }

    Text {
        id: pos1
        text: "1."
        font.pixelSize: 30
        x: 30
        anchors.top: lvl.bottom
        anchors.topMargin: 10
        color:  "#00ff00"
    }

    Text {
        id: pos2
        text: "2."
        font.pixelSize: 30
        x: 30
        anchors.top: pos1.bottom
        anchors.topMargin: 10
        color:  "#00ff00"
    }

    Text {
        id: pos3
        text: "3."
        font.pixelSize: 30
        x: 30
        anchors.top: pos2.bottom
        anchors.topMargin: 10
        color:  "#00ff00"
    }

    Text {
        id: pos4
        text: "4."
        font.pixelSize: 30
        x: 30
        anchors.top: pos3.bottom
        anchors.topMargin: 10
        color:  "#00ff00"
    }

    Text {
        id: pos5
        text: "5."
        font.pixelSize: 30
        x: 30
        anchors.top: pos4.bottom
        anchors.topMargin: 10
        color:  "#00ff00"
    }

    Text {
        id: pos6
        text: "6."
        font.pixelSize: 30
        x: 30
        anchors.top: pos5.bottom
        anchors.topMargin: 10
        color:  "#00ff00"
    }

    Text {
        id: pos1lvl
        text: "0"
        font.pixelSize: 30
        x: 30
        anchors.top: pos1.top
        anchors.left: pos1.right
        anchors.leftMargin: 30
        color:  "#00ff00"
    }

    Text {
        id: pos2lvl
        text: "0"
        font.pixelSize: 30
        x: 30
        anchors.top: pos2.top
        anchors.left: pos2.right
        anchors.leftMargin: 30
        color:  "#00ff00"
    }

    Text {
        id: pos3lvl
        text: "0"
        font.pixelSize: 30
        x: 30
        anchors.top: pos3.top
        anchors.left: pos3.right
        anchors.leftMargin: 30
        color:  "#00ff00"
    }

    Text {
        id: pos4lvl
        text: "0"
        font.pixelSize: 30
        x: 30
        anchors.top: pos4.top
        anchors.left: pos4.right
        anchors.leftMargin: 30
        color:  "#00ff00"
    }

    Text {
        id: pos5lvl
        text: "0"
        font.pixelSize: 30
        x: 30
        anchors.top: pos5.top
        anchors.left: pos5.right
        anchors.leftMargin: 30
        color:  "#00ff00"
    }

    Text {
        id: pos6lvl
        text: "0"
        font.pixelSize: 30
        x: 30
        anchors.top: pos6.top
        anchors.left: pos6.right
        anchors.leftMargin: 30
        color:  "#00ff00"
    }

    Text {
        id: pos1scr
        text: "0"
        font.pixelSize: 30
        x: 30
        anchors.top: pos1.top
        anchors.left: score.left
        color:  "#00ff00"
    }

    Text {
        id: pos2scr
        text: "0"
        font.pixelSize: 30
        x: 30
        anchors.top: pos2.top
        anchors.left: score.left
        color:  "#00ff00"
    }

    Text {
        id: pos3scr
        text: "0"
        font.pixelSize: 30
        x: 30
        anchors.top: pos3.top
        anchors.left: score.left
        color:  "#00ff00"
    }

    Text {
        id: pos4scr
        text: "0"
        font.pixelSize: 30
        x: 30
        anchors.top: pos4.top
        anchors.left: score.left
        color:  "#00ff00"
    }

    Text {
        id: pos5scr
        text: "0"
        font.pixelSize: 30
        x: 30
        anchors.top: pos5.top
        anchors.left: score.left
        color:  "#00ff00"
    }

    Text {
        id: pos6scr
        text: "0"
        font.pixelSize: 30
        x: 30
        anchors.top: pos6.top
        anchors.left: score.left
        color:  "#00ff00"
    }

    function refreshScores() {
        Settings.loadSettings();
        pos1lvl.text = parseFloat(Settings.Pos1Level).toFixed(0);
        pos1scr.text = parseFloat(Settings.Pos1Score).toFixed(0);
        pos2lvl.text = parseFloat(Settings.Pos2Level).toFixed(0);
        pos2scr.text = parseFloat(Settings.Pos2Score).toFixed(0);
        pos3lvl.text = parseFloat(Settings.Pos3Level).toFixed(0);
        pos3scr.text = parseFloat(Settings.Pos3Score).toFixed(0);
        pos4lvl.text = parseFloat(Settings.Pos4Level).toFixed(0);
        pos4scr.text = parseFloat(Settings.Pos4Score).toFixed(0);
        pos5lvl.text = parseFloat(Settings.Pos5Level).toFixed(0);
        pos5scr.text = parseFloat(Settings.Pos5Score).toFixed(0);
        pos6lvl.text = parseFloat(Settings.Pos6Level).toFixed(0);
        pos6scr.text = parseFloat(Settings.Pos6Score).toFixed(0);
    }

    Component.onCompleted: refreshScores();

}
